﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Controls
{
    /// <summary>
    /// Interaction logic for ContentControls.xaml
    /// </summary>
    public partial class ContentControls : Window
    {
        public ContentControls()
        {
            InitializeComponent();
        }

        private void LogEvent(object sender, RoutedEventArgs e)
        {
            var evt = e.RoutedEvent.Name;
            var src = ((FrameworkElement)e.Source).Name;
            var oscr = e.OriginalSource.GetType().Name;
            var snd = ((FrameworkElement)sender).Name;
            TextField.Text = $"{evt} - source: {src}; original source {oscr}; sender {snd}";
        }

        private void AskQuestion(object sender, RoutedEventArgs e)
        {
            var dlg = new SimpleDialog();
            var r = dlg.ShowDialog();
            if (r != null)
                TextField.Text = "Your answer: " + (r == true ? "Yes" : "No");
        }

        private void OnAAAAA(object sender, RoutedEventArgs e)
        {
            TextField.Text += "A";
        }
    }

    public class CheckedToContentConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var v = (bool?)value;
            return v switch
            {
                false => "Unchecked",
                true => "Checked",
                _ => "Indeterminate"
            };
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
            => DependencyProperty.UnsetValue;
    }
}
