﻿using System;
using System.Globalization;
using Precedence.Controls;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

namespace Controls
{
    /// <summary>
    /// Interaction logic for DPPrecedence.xaml
    /// </summary>
    public partial class Precedences : Window
    {


        public Precedences()
        {
            InitializeComponent();
        }

        private MyControl mc
        {
            get => (MyControl)mcHost.Template.FindName("mc", mcHost);
        }
        
        /*
         * Properties that should be inherited should be registered as attached properties (as is the case with
         * MyControlMyValue). This allows to set it on elements of any type (for non-attached dependency properties
         * the element's class or some base class needs to be the owner of such property - by registering it or adding
         * itself as its owner - to be able to assign it). Nevertheless we add the window class as the owner of
         * MyValue property to demonstrate how default values work with inheritance (and also for convenience).
         *
         * Note that different default value was given here than in MyControl. Inheritance precedes the default value,
         * so any value of MyValue property for the window should trump the default of MyControl contained within.
         * However, if both are default, barring any other sources of the value, each gets the default appropriate
         * for its type.
         */
        public static readonly DependencyProperty MyValueProperty = 
            Precedence.Controls.MyControl.MyValueProperty.AddOwner(typeof(Precedences),
                new FrameworkPropertyMetadata(-1, FrameworkPropertyMetadataOptions.Inherits));

        public int MyValue
        {
            get => (int)GetValue(MyValueProperty);
            set => SetValue(MyValueProperty, value);
        }


        private void ToggleInheritedValue(object sender, RoutedEventArgs e)
        {
            if (((CheckBox)sender).IsChecked == true)
                SetValue(MyValueProperty, 1);
            else
                ClearValue(MyValueProperty);
        }

        private void AssignStyle(object sender, RoutedEventArgs e)
        {
            if (((CheckBox)sender).IsChecked == true)
                mc.Style = (Style)FindResource("MyControlStyle");
            else
                mc.ClearValue(StyleProperty);
        }

        private void SetLocalValue(object sender, RoutedEventArgs e)
        {
            if (((CheckBox)sender).IsChecked == true)
                mc.MyValue = 9;
            else
                mc.ClearValue(MyValueProperty);
        }

        private void SetCurrent(object sender, RoutedEventArgs e)
        {
            mc.SetCurrentValue(MyControl.MyValueProperty, 11);
        }
    }
}
