﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApp1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            AddHandler(PreviewMouseLeftButtonDownEvent, new MouseButtonEventHandler(LogEvent)/*delegate must be created explicitly*/);
            AddHandler(MouseLeftButtonUpEvent, new MouseButtonEventHandler(LogEvent), true);
            AddHandler(Button.ClickEvent, new RoutedEventHandler(LogEvent));
            innerLabel.MouseLeftButtonUp += LogEvent; //delegate created automatically
            innerLabel.AddHandler(PreviewMouseLeftButtonDownEvent, new MouseButtonEventHandler(LogEvent), true);
        }

        private void LogEvent(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine(
                $"{e.RoutedEvent.Name} - source: {((FrameworkElement)e.Source).Name}; original source {e.OriginalSource.GetType().Name}; sender {((FrameworkElement)sender).Name}");

        }

        private void LogAndHandleEvent(object sender, RoutedEventArgs e)
        {
            LogEvent(sender, e);
            e.Handled = true;
        }
    }
}
