﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace Precedence.Controls
{
    public class MyValueToSourceConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (parameter is not DependencyObject)
                throw new ArgumentException("Must supply DependencyObject instance!", nameof(parameter));
            var ctrl = (DependencyObject)parameter;
            var vsrc = DependencyPropertyHelper.GetValueSource(ctrl, MyControl.MyValueProperty);
            var source = vsrc switch
            {
                { IsCurrent: true } => "SetCurrentValue",
                { IsCoerced: true } => "CoerceCallback",
                { IsAnimated: true } => "Animation",
                _ => vsrc.BaseValueSource.ToString()
            };
            return $"Current Value: [{value}] Source: [{source}] Base Value Source: [{vsrc.BaseValueSource}]";
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
